<?php
// Copyright (C) 2009 Martin "Arcao" Sloup <arcao@arcao.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

$url = 'svn://svn.example.com/path';
$username = 'anonymous';
$password = '';

//------------ do not edit bellow
$path = $_GET['path'];
$rev = isset($_GET['rev'])? (int)$_GET['rev']: -1;
$query = ($rev!=-1) ? '?rev='.$rev : '';

require('svn.class.php');
require('mime.types.php');

if (strlen($path) == 0 || $path[0] != '/')
	$path = '/'.$path;

try {
	$svn = new svn($url, $username, $password);
	
	$lastRev = $svn->getLastRev();
	if ($rev==-1) $rev = $lastRev;
	
	$rev = max($rev, 0);
	$rev = min($rev, $lastRev);
	
	$fileType = $svn->checkPath($path, $rev);
	
	if ($fileType == 'file') {
		$info = pathinfo($path);
		$ext = $info['extension'];
	
		$contentType = 'text/plain';
		if ($ext && isset($mime_types[$ext]))
			 $contentType = $mime_types[$ext];
		
		$stat = $svn->stat($path, $rev);
		
		header("Content-Type: {$contentType}", true);
		header("Content-Length: {$stat['size']}", true);
		
		$fp = Fopen('php://output', 'w');
		if ($fp) {
			$svn->getFile($path, $fp, $rev);
		} else {
			header("HTTP/1.0 500 Internal Server Error");
		}
	} elseif ($fileType == 'dir') {
		if (substr($path, -1) == '/') {
			$dir = $svn->getDir($path, $rev);
		
			require('dir.template.php');
		} else {
			Header("Location: http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"].'/', true, 301); 
		}	
	} else {
		header("HTTP/1.0 404 Not Found");
		require('notfound.template.php');
	}
	$svn->close();
} catch (Exception $e) {
	header("HTTP/1.0 500 Internal Server Error");
	echo 'Error: ',  $e->getMessage(), "\n";
}
